Index: uk/me/parabola/mkgmap/main/MapMaker.java
===================================================================
--- uk/me/parabola/mkgmap/main/MapMaker.java	(revision 2883)
+++ uk/me/parabola/mkgmap/main/MapMaker.java	(working copy)
@@ -216,19 +216,27 @@
 		}
 	}
 
-	private boolean roadsAreJoined(MapLine r1, MapLine r2) {
+	private boolean roadsAreJoined(MapRoad r1, MapRoad r2) {
 		if (r1.getBounds().intersects(r2.getBounds()) == false)  {
 			return false;
 		}
-
+		boolean r2883Res = false;
 		if(r1 != r2) {
 			for(Coord c1 : r1.getPoints()) {
+				if (c1.getId() == 0)
+					continue;
 				for(Coord c2 : r2.getPoints()) {
-					if(c1 == c2 || c1.equals(c2))
+					if (c2.getId() == 0)
+						continue;
+					if (c1.getId() == c2.getId())
 						return true;
+					else if(c1.equals(c2))
+						r2883Res = true;
 				}
 			}
 		}
+		if (r2883Res == true)
+			log.error("mkgmap r2883 and older would see roads " + r1.getRoadDef().getId() + " and " + r2.getRoadDef().getId() + " as connected, but they are not");
 		return false;
 	}
 
